import re
import sys
import time
import telnetlib
from ftplib import FTP

class xTelnet:
    def __init__(self,ip=None,port=23):
        self._ip=ip
        self._port=port
        self._t=None
        self.expect=None
        
    def __del__(self):
        if self._t:
            self._t.close()
            self._t=None
            
    def cmd(self,str):
        if self._t:
            self._t.write(str+'\r\n')
            return self._t.read_until(self.expect)
        else:
            return ''   
    
    def cmdexpect(self,str,expect=None,to=0):
        if self._t:
            self._t.write(str+'\r\n')
            if to!=0:
                time.sleep(to)
            return self._t.read_until(expect)
        else:
            return ''
    
    def cmdonly(self,str):
        if self._t:
            self._t.write(str+'\r\n')        
    
    def readany(self):
        if self._t:
            return self._t.read_very_lazy() 
        else:
            return ''
     
    def setexpect(self,expect):
        self.expect=expect

                
    def login(self,prompt,user,password):
        if self._t==None:
            return "not valid telnet handle"

        if type(user["prompt"])==list:
            self._t.expect(user["prompt"])
        else:
            self._t.read_until(user["prompt"])

        self._t.write(user["value"]+"\r\n")
        if password["value"]:
            if type(password["prompt"])==list:
                self._t.expect(password["prompt"])
            else:
                self._t.read_until(password["prompt"])
            self._t.write(password["value"]+"\r\n" )

        if type(prompt)==list:
            r=self._t.expect(prompt)
            if r[0]!=-1:
                self.expect=prompt[r[0]]
        else:
            self.expect=prompt
            self._t.read_until(prompt)
        if self.expect[0]=="\\":
            self.expect=self.expect[1:]  

    def connect(self,user=None,pwd=None,prompt='$'):
        resp=''
        try:
            self._t=telnetlib.Telnet(self._ip,self._port)
            resp=self.login(prompt,{'prompt':'login:','value':user},{'prompt':'Password:','value':pwd})
        except socket.error,e:
            print "error",e
            self._t=None
            resp=e[1]
        return [self._t,resp] 
        
    def disconnect(self):
        if self._t:
            self._t.close()
            self._t=None        

def telnetCmds(telnetIP,telnetPort,user,pwd,prompt,cmds,interval=0.00000005):
    lastcmd=cmds[-1]
    del cmds[-1]
    t=None
    try:
        t=xTelnet(telnetIP,telnetPort)
        t.connect(user,pwd,prompt)
        for cmd in cmds:
            t.cmd(cmd)
            if interval!=0:
                time.sleep(interval)
        return t.cmd(lastcmd)
    except:
        return ''
    finally:
        if t:
            t.disconnect()

if __name__ == '__main__':
    def usage():
        s="Usage:"
        s+="%s isRename STBIP passWord\n"%sys.argv[0]
        s+="\t isRename: 0:pc->stb hw_test 1:stb->pc hw_test2\n"
        s+="\t stbip: stb's ipaddress\n"
        s+="\t passWord: passWord\n"
        print s.decode('utf-8').encode('gbk')
        
    def isIP(ip):
        m=re.match('^(\d+)\.(\d+).(\d+).(\d+)$',ip.strip())
        if m:
            isOK=True
            for i in range(1,5):
                ip=int(m.group(i))
                if ip>255:
                    isOK=False
                    break
            return isOK
        else:
            return False        
    def handleDownload(block):
        file.write(block)
        print ".",

    if len(sys.argv)<4:
        usage()
        sys.exit(-1)
      
    try:    
        isRename=int(sys.argv[1])
    except:
        print "isRename expect a 0 or 1,you input %s"%sys.argv[1]
        print "Unexpected error:", sys.exc_info()[0]
        sys.exit(-1)
    if isRename<0 or isRename>3:
        print "isRename expect a 0 or 1 or2 or 3,you input %s"%sys.argv[1]
        sys.exit(-1) 
          
    stbip=sys.argv[2]
    if not isIP(stbip):
        print "stbip should be a valid ip,you input %s"%sys.argv[2]
        sys.exit(-1)
        
    passWord=sys.argv[3]

    if isRename==0:
        tn = telnetlib.Telnet(stbip,23)
        tn.read_until('login:')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write(passWord+'\r\n')
        tn.read_until('$')
        tn.write('cd /\r\n')
        tn.read_until('$')
        tn.write('./mnt/app/bin/ftp&\r\n')
        tn.read_until('$')
        tn.write('cd /etc/\r\n')
        tn.read_until('$')
        tn.write('rm -r stb.txt\r\n')
        tn.read_until('$')
        tn.write('cp stb.cfg stb.txt\r\n')
        tn.read_until('$')
        tn.write('ftp 192.168.1.15\r\n')
        tn.read_until('root): ')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write('ZTE_bAvO\r\n')
        tn.read_until('ftp> ')
        tn.write('cd FTP\r\n')
        tn.read_until('ftp> ')
        tn.write('put stb.txt\r\n')
        tn.write('bye\r\n')
        tn.read_until('$')
        tn.write('exit\r\n')
    if isRename==1:
        tn = telnetlib.Telnet(stbip,23)
        tn.read_until('login:')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write(passWord+'\r\n')
        tn.read_until('# ')
        tn.write('cd /\r\n')
        tn.read_until('# ')
        tn.write('./cramfs/bin/ftp&\r\n')
        tn.read_until('# ')
        tn.write('cd /etc/\r\n')
        tn.read_until('# ')
        tn.write('rm -r stb.txt\r\n')
        tn.read_until('# ')
        tn.write('cp stb.cfg stb.txt\r\n')
        tn.read_until('# ')
        tn.write('ftp 192.168.1.15\r\n')
        tn.read_until('root): ')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write('ZTE_bAvO\r\n')
        tn.read_until('ftp> ')
        tn.write('cd FTP\r\n')
        tn.read_until('ftp> ')
        tn.write('put stb.txt\r\n')
        tn.write('bye\r\n')
        tn.read_until('# ')
        tn.write('exit\r\n')
    if isRename==2:
        tn = telnetlib.Telnet(stbip,23)
        tn.read_until('login:')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write(passWord+'\r\n')
        tn.read_until('#')
        tn.write('cd /\r\n')
        tn.read_until('#')
        tn.write('./cramfs/bin/ftp&\r\n')
        tn.read_until('#')
        tn.write('cd /etc/\r\n')
        tn.read_until('#')
        tn.write('rm -r stb.txt\r\n')
        tn.read_until('#')
        tn.write('cp stb.cfg stb.txt\r\n')
        tn.read_until('#')
        tn.write('ftp 192.168.1.15\r\n')
        tn.read_until('root): ')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write('ZTE_bAvO\r\n')
        tn.read_until('ftp> ')
        tn.write('cd FTP\r\n')
        tn.read_until('ftp> ')
        tn.write('put stb.txt\r\n')
        tn.write('bye\r\n')
        tn.read_until('#')
        tn.write('exit\r\n')
    if isRename==3:
        tn = telnetlib.Telnet(stbip,23)
        tn.read_until('login:')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write(passWord+'\r\n')
        tn.read_until('#')
        tn.write('cd /\r\n')
        tn.read_until('#')
        tn.write('ftp&\r\n')
        tn.read_until('#')
        tn.write('cd /etc/\r\n')
        tn.read_until('#')
        tn.write('rm -r stb.txt\r\n')
        tn.read_until('#')
        tn.write('cp stb.cfg stb.txt\r\n')
        tn.read_until('#')
        tn.write('ftp 192.168.1.15\r\n')
        tn.read_until('root): ')
        tn.write('root\r\n')
        tn.read_until('Password:')
        tn.write('ZTE_bAvO\r\n')
        tn.read_until('ftp> ')
        tn.write('cd FTP\r\n')
        tn.read_until('ftp> ')
        tn.write('put stb.txt\r\n')
        tn.write('bye\r\n')
        tn.read_until('#')
        tn.write('exit\r\n')
   
    sys.exit(0)